import es
import playerlib
import random
import gamethread
import soccer.soccer as soccerlib
import psyco
from spe import detourFunction
from spe import HookAction
from spe import HookType
from spe import makeObject
from spe import undetourFunction
from spe.tools.player import SPEPlayer
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Health Script"
info.version = soccerlib.info.version
info.basename = "soccerhealth"
info.author = "chrismrulz"

spawnmode = int(soccerlib.config["Respawn"]["spawnmode"])
disableknives = int(soccerlib.config["Health"]["disableknives"])
healthmode = int(soccerlib.config["Health"]["healthmode"])
clearbodies = int(soccerlib.config["Health"]["clearbodies"])
godmode_respawn = int(soccerlib.config["Health"]["godmode_respawn"])
godmode_re = 0

def load():
  es.msg("#Green", "Soccer Health Script On - by Toph")
  loadblock()

def unload():
  es.msg("#Green", "Soccer Health Script Off")
  if(disableknives == 1):
    undetourFunction('OnTakeDamage', HookType.Pre, player_hurt_pre)
  if(healthmode == 3):
    gamethread.queue(es.unload, 'soccer/soccerrespawn')

def es_map_start(event_var):
  loadblock()

def loadblock():
  if(healthmode == 3):
    gamethread.queue(es.load, 'soccer/soccerrespawn')
    if(spawnmode == 1):
      gamethread.queue(es.unload, 'soccer/soccerhealth')
  if(disableknives == 1):
    detourFunction('OnTakeDamage', HookType.Pre, player_hurt_pre)

def player_hurt_pre(args):
	info = makeObject('CTakeDamageInfo', args[0])
	userid = es.getuserid(info.hAttacker)
	if(userid != 0):
		if info.hAttacker == info.hInflictor:
			return (HookAction.Override, 0)
	return (HookAction.Continue, 0)

def round_start(event_var):
  if(healthmode == 2):
    rp = soccerlib.rp()
    if(rp != 0):
      soccerlib.dofire(rp, 'terro_But', 'addoutput \"OnTrigger point_servercommand,command,es_xdoblock soccer/soccerhealth/tgoal\"')
      soccerlib.dofire(rp, 'ct_But', 'addoutput \"OnTrigger point_servercommand,command,es_xdoblock soccer/soccerhealth/ctgoal\"')
    global godmode_re
    godmode_re = 0

def godmode(pfilter, on = 1):
  myPlayerList = playerlib.getUseridList(pfilter)
  for userid in myPlayerList:
    if(on == 1):
      es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0)
    else:
      es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 512)

def tgoal():
  godmode('#t', 0)
  global godmode_re
  godmode_re = 1

def ctgoal():
  godmode('#ct', 0)
  global godmode_re
  godmode_re = 1

def player_hurt(event_var):
  if(healthmode != 2):
    es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 250)

def player_death(event_var):
  gmrs(event_var['userid'])
  if(clearbodies != 0):
    gamethread.delayed(int(clearbodies), es.fire, (event_var['userid'], 'cs_ragdoll kill'))

def player_team(event_var):
  gmrs(event_var['userid'])

def gmrs(uid):
  if(healthmode == 2 and godmode_respawn == 1 and godmode_re == 0):
    soccerlib.spawn(uid)

def player_spawn(event_var):
  if(healthmode != 2):
    es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 250)
  elif(healthmode == 2):
    godmode(event_var['userid'])